<?php
header("content-type:text/html; charset=utf-8");
class Gateway_Ipasspay_Block_Redirect extends Mage_Core_Block_Template {
    protected $_order;
    public function getOrder() {
        if ($this->_order == null) {
            $session = Mage::getSingleton('checkout/session');
            $this->_order = Mage::getModel('sales/order');
            $this->_order->loadByIncrementId($session->getLastRealOrderId());
        }
        return $this->_order;
    }
    protected function _toHtml() {
        $media_url = Mage::getBaseUrl('media');
        $standard = Mage::getModel('ipasspay/payment');
        $cardid = $_SESSION['card_no'];
        $ex_month = $_SESSION['card_ex_month'];
        $ex_year = $_SESSION['card_ex_year'];
        $cvv2 = $_SESSION['card_cvv'];

        // execute the page and then jump.
        $htmldiv = '<style type="text/css">#t01 {margin: auto;margin-top: 150px;text-align: center;border: 1px solid #a1a1a1;padding: 10px 40px;width: 500px;height: 110px;border-radius: 6px;-moz-border-radius: 6px;box-shadow: 3px 3px 3px #888888;border-radius: 6px;-moz-border-radius: 6px;box-shadow: 3px 3px 3px #888888;-moz-box-shadow: 3px 3px 3px #888888;}</style>';
        $htmldiv .= '<div id="t01"><br /><br /><img src="' . $media_url . '/ipasspay_logo/loading.gif" /><br /><br /><span>Please wait,transaction processing ...</span></div>';
        echo $htmldiv;
        $strValue = $standard->setOrder($this->getOrder())->getStandardCheckoutFormFields();
        $strValue = $strValue . "&card_no=" . urlencode($cardid) . "&card_cvv=" . urlencode($cvv2) . "&card_ex_year=" . urlencode($ex_year) . "&card_ex_month=" . urlencode($ex_month);
        //echo "Data submitted to the payment gateway:" . $strValue;
        $url_server = $standard->getIpasspayUrl(); // Payment gateway url
        //echo "payment gateway url:" . $url_server;
        $ip = $standard->getIp();

        //echo $ip;exit;
        $curl = curl_init();
        $wesite = $_SERVER['HTTP_HOST'];
        curl_setopt($curl, CURLOPT_URL, $url_server);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array('X-FORWARDED-FOR:' . $ip, 'CLIENT-IP:' . $ip));
        curl_setopt($curl, CURLOPT_HEADER, 0);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
        curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $strValue);
        curl_setopt($curl, CURLOPT_REFERER, $wesite);
        if ($url_server) {
            curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        }
        $response = curl_exec($curl);
        curl_close($curl);
        //echo "the return from gateway:" . $response;
        // 		exit;
        $html = '';
        $url_back = $standard->getBackUrl(); // success return url
        if ($response != "") {
            $arr_res = json_decode($response, true);
            if ($arr_res['status'] == 1) {
                $status = $arr_res['status'];
                $order_status = $arr_res['data']['order_status'];
                $oid = $arr_res['data']['oid'];
                $pid = $arr_res['data']['pid'];
                $Amount = $arr_res['data']['order_amount'];
                $currency = $arr_res['data']['order_currency'];
                $hash_info = $arr_res['data']['hash_info'];
                $notification_url = $arr_res['data']['syn_url'];
                $info = $arr_res['info'];
                $oid1 = $this->getOrder()->getId();

                $html = '<form action="' . $url_back . '" id="form1" method="post">';
                $html .= '<input type="hidden" name="status" value="' . $status . '" />';
                $html .= '<input type="hidden" name="order_status" value="' . $order_status . '" />';
                $html .= '<input type="hidden" name="oid" value="' . $oid . '" />';
                $html .= '<input type="hidden" name="oid1" value="' . $oid1 . '" />';
                $html .= '<input type="hidden" name="pid" value="' . $pid . '" />';
                $html .= '<input type="hidden" name="Amount" value="' . $Amount . '" />';
                $html .= '<input type="hidden" name="currency" value="' . $currency . '" />';
                $html .= '<input type="hidden" name="hash_info" value="' . $hash_info . '" />';
                $html .= '<input type="hidden" name="notification_url" value="' . $notification_url . '" />';
                $html .= '<input type="hidden" name="info" value="' . $info . '"/></form>';
            } else {
                $data = $arr_res['data'];
                $info = $arr_res['info'];
                $status = $arr_res['status'];
                $oid1 = $this->getOrder()->getId();

                $html = '<form action="' . $url_back . '" id="form1" method="post">';
                $html .= '<input type="hidden" name="oid1" value="' . $oid1 . '" />';
                $html .= '<input type="hidden" name="status" value="' . $status . '" />';
                $html .= '<input type="hidden" name="data" value="' . $data . '" />';
                $html .= '<input type="hidden" name="info" value="' . $info . '"/></form>';
            }
            $html .= '<script type="text/javascript">
					setTimeout("redct()", 3000);
					function redct(){
					    document.getElementById("form1").submit();
					}</script>';
            echo $html;
        } else {
            // pay back is empty
            $info = "Pay back is empty, please pay again.";
            $status = 0;
            $oid1 = $this->getOrder()->getId();

            $html = '<form action="' . $url_back . '" id="form1" method="post">';
            $html .= '<input type="hidden" name="oid1" value="' . $oid1 . '" />';
            $html .= '<input type="hidden" name="status" value="' . $status . '" />';
            $html .= '<input type="hidden" name="info" value="' . $info . '"/></form>';
            $html .= '<script type="text/javascript">
					setTimeout("redct()", 1000);
					function redct(){
					    document.getElementById("form1").submit();
					}</script>';
            echo $html;

        }
    }
}
?>
